'=======================================================
'EViews Liquor Sales Code
'Econometrics (ECON 104)
'2017

'Code by Prof. Diebold, Donato Onorato, JoonYup Park, Theodore Caputi, 
                 'Sarah Winton

'Updates: 

   '6/29/2017: Donato Onorato added Quandt-Andrews manual test
   '6/29/2017: Donato Onorato added 4 lagged log sales terms to the 
   '                    Quandt-Andrews, Chow test code
   '7/5/2017: Donato Onorato added HAC standard errors example, Breusch-Godfrey
   '                    serial correlation tests for AR1, AR2, AR4

'=======================================================


'cd "C:\Users\fdiebold\Dropbox\AAA_Diebold\AAA_BooksAndCourses\Book_Econometrics\MasterDataAndCode\Code_EViews\EViews_Liquor"

cd "C:\Users\fdiebold\Dropbox\Econometrics\MasterDataAndCode_HOT\Code_EViews\EViews_Liquor"


'cd "C:\Users\krb-user66\Downloads\"

workfile WorkFileLiquor m 1982m1 2053m12

smpl 1987m1 2014m12

read DataLiquor.csv sales

genr lsales=@log(sales)

genr time=@trend(1986m12)
genr time2=time^2

genr D1=@seas(1)
genr D2=@seas(2)
genr D3=@seas(3)
genr D4=@seas(4)
genr D5=@seas(5)
genr D6=@seas(6)
genr D7=@seas(7)
genr D8=@seas(8)
genr D9=@seas(9)
genr D10=@seas(10)
genr D11=@seas(11)
genr D12=@seas(12)

smpl 1987m1 2014m12

'freeze(Figure101) sales.line
'Figure101.addtext(t) Liquor Sales
'Figure101.addtext(l) Sales
'Figure101.addtext(b) Time
'Figure101.scale(left) range(0,3000)
'Figure101.datelabel format(yy)
'Figure101.legend -display
'Figure101.setelem symbol(none)
''Figure101.options -color
'Figure101.axis(a) label
'Figure101.setelem(1) linepattern(1)
'show Figure101
'
'freeze(Figure102) lsales.line
'Figure102.addtext(t) Log Liquor Sales
'Figure102.addtext(l) Log Sales
'Figure102.addtext(b) Time
'Figure102.scale(left) range(6.0,8.0)
'Figure102.datelabel format(yy)
'Figure102.legend -display
'Figure102.setelem symbol(none)
''Figure102.options -color
'Figure102.axis(a) label
'Figure102.setelem(1) linepattern(1)
'show Figure102
'
'
''linear trend stuff
'
'smpl 1987m1 2014m12
'
'equation Table100.ls lsales c time
'
'show Table100
'
'freeze(Figure1093) Table100.resid
''Figure1093.addtext(t) Figure 10.3 Log Liquor Sales Quadratic Trend Regression Residual Plot
'Figure1093.scale(left) range(-0.4,0.6)
'Figure1093.scale(right) range(6.0,8.0)
'Figure1093.datelabel format(yy)
'Figure1093.legend display
'Figure1093.setelem symbol(none)
''Figure1093.options -color
'Figure1093.axis(a) label
'Figure1093.setelem(1) linepattern(1)
'Figure1093.setelem(2) linepattern(2)
'Figure1093.setelem(3) linepattern(3)
'show Figure1093
'
''freeze(Table102) Table101.correl(36)
'
'
'
''*****Linear trend with seas dummies
'
'smpl 1987m1 2014m12
'
'equation Table203.ls lsales time D1 D2 D3 D4 D5 D6 D7 D8 D9 D10 D11 D12
'
'show Table203
'
'freeze(Figure205) Table203.resid
''Figure105.addtext(t) Figure 10.5 Log Liquor Sales Quadratic Trend Regression with Seasonal Dummies Residual Plot
'Figure205.scale(left) range(-0.15,0.15)
'Figure205.scale(right) range(6.0,8.0)
'Figure205.datelabel format(yy)
'Figure205.legend display
'Figure205.setelem symbol(none)
''Figure105.options -color
'Figure205.axis(a) label
'Figure205.setelem(1) linepattern(1)
'Figure205.setelem(2) linepattern(2)
'Figure205.setelem(3) linepattern(3)
'
'show Figure205
'
'smpl 1987.01 1987.01
'genr seasfactors=c(2)
'
'smpl 1987.02 1987.02
'genr seasfactors=c(3)
'
'smpl 1987.03 1987.03
'genr seasfactors=c(4)
'
'smpl 1987.04 1987.04
'genr seasfactors=c(5)
'
'smpl 1987.05 1987.05
'genr seasfactors=c(6)
'
'smpl 1987.06 1987.06
'genr seasfactors=c(7)
'
'smpl 1987.07 1987.07
'genr seasfactors=c(8)
'
'smpl 1987.08 1987.08
'genr seasfactors=c(9)
'
'smpl 1987.09 1987.09
'genr seasfactors=c(10)
'
'smpl 1987.10 1987.10
'genr seasfactors=c(11)
'
'smpl 1987.11 1987.11
'genr seasfactors=c(12)
'
'smpl 1987.12 1987.12
'genr seasfactors=c(13)
'
'
'smpl 1987.01 1987.12
'freeze(Figure208) seasfactors.line
'Figure208.addtext(t) Estimated Seasonal Factors
'Figure208.addtext(l)  Factor
'Figure208.addtext(b) Month
'Figure208.legend -display
'Figure208.setelem symbol(none)
''Figure208.axis(a) label
'Figure208.setelem(1) linepattern(1)
'show Figure208
'
'
''*****Quad trend stuff
'
'smpl 1987m1 2014m12
'
'equation Table101.ls lsales c time time2
'
'show Table101
'
'freeze(Figure103) Table101.resid
''Figure103.addtext(t) Figure 10.3 Log Liquor Sales Quadratic Trend Regression Residual Plot
'Figure103.scale(left) range(-0.4,0.6)
'Figure103.scale(right) range(6.0,8.0)
'Figure103.datelabel format(yy)
'Figure103.legend display
'Figure103.setelem symbol(none)
''Figure103.options -color
'Figure103.axis(a) label
'Figure103.setelem(1) linepattern(1)
'Figure103.setelem(2) linepattern(2)
'Figure103.setelem(3) linepattern(3)
'
'show Figure103
'
''freeze(Table102) Table101.correl(36)
'
'
'
'
'
'smpl 1987m1 2014m12
'
'equation Table103.ls lsales time time2 D1 D2 D3 D4 D5 D6 D7 D8 D9 D10 D11 D12
'
'show Table103
'
'freeze(Figure105) Table103.resid
''Figure105.addtext(t) Figure 10.5 Log Liquor Sales Quadratic Trend Regression with Seasonal Dummies Residual Plot
'Figure105.scale(left) range(-0.15,0.15)
'Figure105.scale(right) range(6.0,8.0)
'Figure105.datelabel format(yy)
'Figure105.legend display
'Figure105.setelem symbol(none)
''Figure105.options -color
'Figure105.axis(a) label
'Figure105.setelem(1) linepattern(1)
'Figure105.setelem(2) linepattern(2)
'Figure105.setelem(3) linepattern(3)
'
'show Figure105
'
'smpl 1987.01 1987.01
'genr seasfactors=c(3)
'
'smpl 1987.02 1987.02
'genr seasfactors=c(4)
'
'smpl 1987.03 1987.03
'genr seasfactors=c(5)
'
'smpl 1987.04 1987.04
'genr seasfactors=c(6)
'
'smpl 1987.05 1987.05
'genr seasfactors=c(7)
'
'smpl 1987.06 1987.06
'genr seasfactors=c(8)
'
'smpl 1987.07 1987.07
'genr seasfactors=c(9)
'
'smpl 1987.08 1987.08
'genr seasfactors=c(10)
'
'smpl 1987.09 1987.09
'genr seasfactors=c(11)
'
'smpl 1987.10 1987.10
'genr seasfactors=c(12)
'
'smpl 1987.11 1987.11
'genr seasfactors=c(13)
'
'smpl 1987.12 1987.12
'genr seasfactors=c(14)
'
'
'smpl 1987.01 1987.12
'freeze(Figure108) seasfactors.line
'Figure108.addtext(l) Seasonal Factor
'Figure108.addtext(b) Month
'Figure108.legend -display
'Figure108.setelem symbol(none)
'Figure108.axis(a) label
'Figure108.setelem(1) linepattern(1)
'show Figure108
'
'
smpl 1987m1 2014m12

equation Table200.ls lsales time time2 D1 D2 D3 D4 D5 D6 D7 D8 D9 D10 D11 D12

show Table200

equation Table201.ls lsales time time2 D1 D2 D3 D4 D5 D6 D7 D8 D9 D10 D11 D12 lsales(-1)

show Table201

equation Table202.ls lsales time time2 D1 D2 D3 D4 D5 D6 D7 D8 D9 D10 D11 D12 lsales(-1) lsales(-2) 

show Table202

equation Table203aaa.ls lsales time time2 D1 D2 D3 D4 D5 D6 D7 D8 D9 D10 D11 D12 lsales(-1) lsales(-2) lsales(-3) 

show Table203aaa

equation Table204.ls lsales time time2 D1 D2 D3 D4 D5 D6 D7 D8 D9 D10 D11 D12 lsales(-1) lsales(-2) lsales(-3) lsales(-4) 

show Table204

equation Table205.ls lsales time time2 D1 D2 D3 D4 D5 D6 D7 D8 D9 D10 D11 D12 lsales(-1) lsales(-2) lsales(-3) lsales(-4) lsales(-5) 

show Table205

equation Table206.ls lsales time time2 D1 D2 D3 D4 D5 D6 D7 D8 D9 D10 D11 D12 lsales(-1) lsales(-2) lsales(-3) lsales(-4) lsales(-5) lsales(-6)

show Table206

equation Table207.ls lsales time time2 D1 D2 D3 D4 D5 D6 D7 D8 D9 D10 D11 D12 lsales(-1) lsales(-2) lsales(-3) lsales(-4) lsales(-5) lsales(-6) lsales(-7)

show Table207

equation Table208.ls lsales time time2 D1 D2 D3 D4 D5 D6 D7 D8 D9 D10 D11 D12 lsales(-1) lsales(-2) lsales(-3) lsales(-4) lsales(-5) lsales(-6) lsales(-7) lsales(-8)

show Table208

equation Table209.ls lsales time time2 D1 D2 D3 D4 D5 D6 D7 D8 D9 D10 D11 D12 lsales(-1) lsales(-2) lsales(-3) lsales(-4) lsales(-5) lsales(-6) lsales(-7) lsales(-8) lsales(-9)

show Table209

equation Table210.ls lsales time time2 D1 D2 D3 D4 D5 D6 D7 D8 D9 D10 D11 D12 lsales(-1) lsales(-2) lsales(-3) lsales(-4) lsales(-5) lsales(-6) lsales(-7) lsales(-8) lsales(-9) lsales(-10)

show Table210



equation Table333.ls lsales time time2 D1 D2 D3 D4 D5 D6 D7 D8 D9 D10 D11 D12 ar(1) ar(2) ar(3) ar(4)

show Table333

'
'Table103.makeresid residA
'
'genr residl1=residA(-1)
'group g1 residl1 residA
'freeze(residl1resid) g1.scat 
'show residl1resid
'




'====================STRUCTURAL CHANGE=====================
'code by Donato Onorato

'Provides tests and techniques for dealing with structural changes in
'the time series data. Included are: Chow Test, Quandt Andrews Test, Regression with Breakpoint Dummy, Expanding Window Plot, Rolling Window Plot


'
'series coeff
'
''expanding window regression
'smpl 1987m01 1997m01
'for !i = 1 to 216
'equation curr.ls lsales time D1 D2 D3 D4 D5 D6 D7 D8 D9 D10 D11 D12
'coeff(!i+180)=curr.@coefs(1)
'smpl 1987m01 1997m01 + !i
'next
'
'smpl 1997m01 2015m01
'freeze(mode=overwrite, expanding_window) coeff.line
'
'
''rolling window regression (window length = 10 year)
'smpl 1987m01 1987m01+120
'series coeff2
'for !i = 1 to 216
'equation curr.ls lsales time D1 D2 D3 D4 D5 D6 D7 D8 D9 D10 D11 D12
'coeff2(!i+60) = curr.@coefs(1)
'smpl 1987m01+!i 1987m01+120+!i
'next
'
'smpl 1987m01 2005m01
'freeze(mode=overwrite, rolling_window) coeff2.line
'
''===========================================================
'

''======================= Quandt-Andrews and Chow Tests=========
'
''manually introduce exogenous breakpoint @2002m10
'
'genr break = 0
'smpl 2002m10 @last
'break = 1
'smpl 1987m01 2014m12
'
''test this break with chow
'equation basic.ls lsales time D1 D2 D3 D4 D5 D6 D7 D8 D9 D10 D11 D12 lsales(-1) lsales(-2) lsales(-3) lsales(-4)
'freeze(exog_chow) basic.chow 2002m10
'
''check the stability of time coefficient
'freeze(exog_chow_time) basic.chow 2002m10 @time
'
''regress on dummy break variable and time interaction
'equation exogenousBreak.ls lsales time D1 D2 D3 D4 D5 D6 D7 D8 D9 D10 D11 D12 time*break break lsales(-1) lsales(-2) lsales(-3) lsales(-4)
'
''plot results
'exogenousBreak.fit fit_exog
'group exog lsales fit_exog
'freeze(mode=overwrite, linear_exog_breakpoint) exog.line 
'
''manual Quandt-Andrews
'
''keep a series of chow F-stats
'series chow_f = 0
''set sample
'smpl 1987m05 2014m12
''keep track of the max f-stat
'scalar f_stat_max =0
'scalar p_stat_max = 0
''keep track of breakpoint with max f-stat
'string break_max = "1990m04"
''basic regression
'equation quandt_reg.ls lsales time D1 D2 D3 D4 D5 D6 D7 D8 D9 D10 D11 D12 lsales(-1) lsales(-2) lsales(-3) lsales(-4)
'
''loop through all observations, with a 15% trim on either side
'for !i = 52 to 283
''increment the chow test date
'%date = @otod(@dtoo("1987m05")+!i)
''perform chow test on that date and freeze result
'freeze(tabchow) quandt_reg.chow {%date}
''extract Wald F-stat from chow test table
'scalar f_stat_curr = @val(tabchow(8,2))
''update the series
'chow_f(!i+63) = f_stat_curr
''check if this f-stat is bigger than the max if so, update the max f-stat and the
''associated max date
'if f_stat_curr >= f_stat_max then
'f_stat_max = f_stat_curr
'break_max = %date
'endif
''delete table to prevent errors
'd tabchow 
'next
'
''delete other things
'd f_stat_curr quandt_reg 
'
''exogenous break as predicted by Quandt-Andrews (2001m10), interactive
'break = 0
'smpl 2001m10 @last
'break = 1
'smpl 1987 2014m12
'
'equation exogenousBreak_2001.ls lsales time D1 D2 D3 D4 D5 D6 D7 D8 D9 D10 D11 D12 time*break break lsales(-1) lsales(-2) lsales(-3) lsales(-4)
'
''plot results
'exogenousBreak_2001.fit fit_exog01
'group exog01 lsales fit_exog01
'freeze(mode=overwrite, linear_exog_breakpoint01) exog01.line
'freeze(exog_reg_res) exogenousBreak_2001.resid


'HAC standard errors for serial correlation
equation temp.ls(cov=hac) lsales time time2 D1 D2 D3 D4 D5 D6 D7 D8 D9 D10 D11 D12
freeze(hac_se) temp
d temp


'Breusch-Godfrey Serial Correlation Test( AR1, AR2. AR4)

'to get exact results from the interactive output (view > residual diagnostics > Serial correlation LM test) you have to put 0's in the presample missing values where the lags were taken you can find an example of this in the AR4 test. For AR1 and AR2 I skipped this, and you will notice that the t-stats are very close but do not exactly match the interactive output

equation temp.ls lsales time time2 D1 D2 D3 D4 D5 D6 D7 D8 D9 D10 D11 D12
temp.makeresid bg_res

'AR1
equation ar1.ls bg_res time time2 D1 D2 D3 D4 D5 D6 D7 D8 D9 D10 D11 D12 bg_res(-1)
scalar T = ar1.@regobs
scalar r2 = ar1.@r2
scalar ar1_stat = T*r2
scalar ar1_pval = @chisq(ar1_stat, 1)
d t r2 

'AR2
equation ar2.ls bg_res time time2 D1 D2 D3 D4 D5 D6 D7 D8 D9 D10 D11 D12 bg_res(-1) bg_res(-2)
scalar T = temp.@regobs
scalar r2 = ar2.@r2
scalar ar2_stat = T*r2
scalar ar2_pval = @chisq(ar2_stat, 2)
d t r2

'AR4
'fix the missing values to 0's as I mentioned above
genr res1 = bg_res(-1)
res1(61) = 0
genr res2 = bg_res(-2)
res2(61) = 0
res2(62) = 0
genr res3 = bg_res(-3)
res3(61) = 0
res3(62) = 0
res3(63) = 0
genr res4 = bg_res(-4)
res4(61) = 0
res4(62) = 0
res4(63) = 0
res4(64) = 0

equation ar4.ls bg_res time time2 D1 D2 D3 D4 D5 D6 D7 D8 D9 D10 D11 D12 res1 res2 res3 res4
scalar T = temp.@regobs
scalar r2 = ar4.@r2
scalar ar4_stat = T*r2
scalar ar4_pval = @chisq(ar4_stat, 2)

'clean up
d res1 res2 res3 res4 ar1 ar2 ar4 t r2 bg_res temp


