'======================================================

'CPS Wage Code
'Econometrics (ECON 104)
'Code by Prof. Diebold, Donato Onorato, JoonYup Park, Theodore Caputi, and 
                 'Sarah Winton
'2017

'Change log:

'                      6/30/2017 Donato Onorato added manual BGP and White tests for
'                                          identifying heteroskedasticity. 

'======================================================

'create workfile for wages

' Please always leave the cd command below.  Comment it out if you don't need it or are setting the cd to look elsewhere.

cd C:\Users\fdiebold\Dropbox\Econometrics\MasterDataAndCode_HOT\Code_EViews\EViews_Wage

'cd C:\Users\krb-user65\Downloads\

wfcreate(wf="WorkFileWages") u 1 1400

smpl 1 1323

read DataWages.csv wage educ exper female union nonwhite age

genr lwage=@log(wage)


''distribtuion of wage and log wage
'freeze(wage_hist) wage.distplot hist(scale=freq, fill)
'freeze(lnwage_hist) wage.distplot hist(scale=freq, fill)
'
''kernel density for wage & log wage
'group gg wage lwage
'freeze(wage_lwage_density) gg.distplot kernel theory(dist = normal)
'
''qqplot for wage & lwage
'freeze(wage_qq) wage.qqplot(s) theory(dist=n)
'wage_qq.setelem(1) lcolor(red) lwidth(1) symbol(filledcircle) fcolor(black)
'wage_qq.setelem(2) lcolor(black) lwidth(1)
'
'freeze(lwage_qq) lwage.qqplot(s) theory(dist=n)
'lwage_qq.setelem(1) lcolor(red) lwidth(1) symbol(filledcircle) fcolor(black)
'lwage_qq.setelem(2) lcolor(black) lwidth(1)
'
'graph qq.merge wage_qq lwage_qq
'
''histograms for lwage, educ, exp
'group g2 lwage educ exper
'freeze(lwage_educ_exper_hist) g2.distplot hist(scale=freq)
'
''scatter with regression line for lwage, educ
'group g1 educ lwage
'freeze(lwage_educ_scat) g1.scat linefit
'
'
'
''simple regression
'
'equation Table1.ls lwage c educ
'
''show Table1
'
'Table1.makeresids res_table1
'Table1.fit fit_table1
'
''multiple regression
'
'equation Table1a.ls lwage c educ exper
'
''
''show Table1a
''
'Table1a.makeresids res_table1a
'Table1a.fit fit_table1a
'
''graph fitted values from 1a
'rename fit_table1a fit
'group g1a fit lwage
'freeze(Figure4_5) g1a.scat
'
'
'freeze(Figure4_6) Table1a.resid
''show Figure4_6
'
'
''plot histograms for educ, exper, nonwhite, union
'group g1b_h educ exper nonwhite union
'freeze(Figure5_1) g1b_h.distplot hist(scale = f)
'
''include dummies
'equation Table1b.ls lwage c educ exper female union nonwhite
'
''show Table1b
'
'Table1b.makeresids res_table1b
'Table1b.fit fit_table1b
'
''RESET test rejects
'
'equation Table1c.ls lwage c educ exper female union nonwhite
'
''show Table1c
'
'Table1c.makeresids res_table1c
'Table1c.fit fit_table1c
'
'reset(2)
'
''plot fitted values for 1c
'fit = fit_table1c 
'group g1c fit lwage
'freeze(Figure5_4) g1c.scat
'
''so include nonlinear and interaction terms
'
''First just nonlinear terms in EDUC and EXPER (some significance)
'
genr educ2=educ^2
genr exper2=exper^2
genr edu_exp=educ*exper
'
'equation Table1fff.ls lwage c educ exper educ2 exper2 edu_exp female union nonwhite 
'
''show Table1fff
'
'Table1fff.makeresids res_table1fff
'Table1fff.fit fit_table1fff
'
''plot squared residuals v. education
'genr res2 = res_table1fff^2
'rename res2 res
'group g1fff educ res 
'freeze(Figure9_1) g1fff.scat
'
''manual BGP test, for detecting heteroskedasticity
'equation testing.ls lwage c educ exper exper2 edu_exp female union nonwhite
'equation bgp_ols.ls res c educ exper exper2 edu_exp female union nonwhite
'scalar N = bgp_ols.@regobs
'scalar R2 = bgp_ols.@r2
'scalar k = bgp_ols.@ncoef - 1 'don't include constant
''the BGP test is approx. Chi-sq(k)
'scalar bgp_test_stat = N*R2
'scalar bgp_pval = @chisq(bgp_test_stat, k)
'd N R2 k
'
''manual White's test
'equation white_ols.ls res c educ^2 educ*exper educ*exper2 educ*edu_exp educ*female educ*union educ*nonwhite educ exper^2 exper*exper2 exper*female exper*union exper*nonwhite exper exper2^2 exper2*edu_exp exper2*female exper2*union exper2*nonwhite edu_exp^2 edu_exp*female edu_exp*union edu_exp*nonwhite female^2 female*union female*nonwhite union^2 union*nonwhite nonwhite^2
'scalar N = white_ols.@regobs
'scalar R2 = white_ols.@r2
'scalar k = white_ols.@ncoef  - 1
''Whites test is approx Chi-sq(k)
'scalar white_test_stat = N*R2
'scalar white_pval = @chisq(white_test_stat, k)
'd N R2 k
'
''Now just nonlinear terms in the dummies (no significance)
'
genr fem_uni = female*union
genr fem_non = female*nonwhite
genr uni_non = union*nonwhite
'
'equation Table1ddd.ls lwage c educ exper female union nonwhite fem_uni fem_non uni_non
'
''show Table1ddd
'
'Table1ddd.makeresids res_table1ddd
'Table1ddd.fit fit_table1ddd
'
'		'Now everything; same thing -- some nonlin effects in EDUC and 			EXPER, nothing with dummies
'
'equation Table1d.ls lwage c educ exper educ2 exper2 edu_exp female union nonwhite fem_uni fem_non uni_non
'
''show Table1d
'
'Table1d.makeresids res_table1d
'Table1d.fit fit_table1d
'
'		'Do RESET again; looks good
'
'equation Table1dd.ls lwage c educ exper educ2 exper2 edu_exp female union nonwhite fem_uni fem_non uni_non
'
''show Table1dd
'
'Table1dd.makeresids res_table1dd
'Table1dd.fit fit_table1dd
'
'reset(2)

	'Also check out the regression using White standard errors

equation Table1e.ls(cov=white) lwage c educ exper educ2 exper2 edu_exp female union nonwhite fem_uni fem_non uni_non

'show Table1e
Table1e.makeresids res_table1e
Table1e.fit fit_table1e

	'Drop dummy interactions since they were never significant

'equation Table1f.ls lwage c educ exper educ2 exper2 edu_exp female union nonwhite 
'
'show Table1f
'
''Table1f.makeresids res_table1f
''Table1f.fit fit_table1f
'
'	'RESET still looks fine
'
'equation Table1ff.ls lwage c educ exper educ2 exper2 edu_exp female union nonwhite 
'
'show Table1ff
'
''Table1ff.makeresids res_table1ff
''Table1ff.fit fit_table1ff
'
'reset(2)
'
'		'Best?
'
'equation Table1ggg.ls lwage c educ exper exper2 edu_exp female union nonwhite 
'
'show Table1ggg
'
''Table1ggg.makeresids res_table1ggg
''Table1ggg.fit fit_table1ggg
'
'
'		'RESET still looks fine
'
'equation Table1gggg.ls lwage c educ exper exper2 edu_exp female union nonwhite 
'
'show Table1gggg
'
''Table1gggg.makeresids res_table1gggg
''Table1gggg.fit fit_table1gggg
'
'reset(2)

'=================FIGURES=======================

'
'		'Histograms
'
'freeze(educHist) educ.hist 'graph01
'show educHist
'
'freeze(experHist) exper.hist 'graph02
'show experHist
'
'freeze(femaleHist) female.hist 'graph03
'show femaleHist
'
'freeze(nonwhiteHist) nonwhite.hist 'graph04
'show nonwhiteHist
'
'freeze(unionHist) union.hist 'graph06
'show unionHist
'
'
'
''3 Hist (EDU, EXP, LWAGE)
'
'freeze(graph401a) lwage.distplot hist
'graph401a.addtext(t) Log Wage
'graph401a.addtext(l) People
'graph401a.addtext(b) Log Wage in Log Dollars
'
'freeze(graph401b) educ.distplot hist
'graph401b.addtext(t) Education
'graph401b.addtext(l) People
'graph401b.addtext(b) Education in Years
'
'freeze(graph401c) exper.distplot hist
'graph401c.addtext(t) Experience
'graph401c.addtext(l) People
'graph401c.addtext(b) Experience in years
'
'graph graph401.merge graph401a graph401b graph401c
'graph401.align(1, 0, 1.5)
'show graph401 'graph08
'
'
''2 Hist (EDU, EXP)
'
'graph graph401ddd.merge  graph401b graph401c
'graph401ddd.align(1, 0, 1.5)
'show graph401ddd  'graph07
'
'
''4 hist (EDU, EXP, UNION, NONWHITE)
'
'freeze(graph5_1a) educ.distplot hist
'graph5_1a.addtext(t) ""
'graph5_1a.addtext(l) ""
'graph5_1a.addtext(b) ""
'graph5_1a.addtext(4.3, .1, ) "Education"
'
'freeze(graph5_1b) exper.distplot hist
'graph5_1b.addtext(t) ""
'graph5_1b.addtext(l) ""
'graph5_1b.addtext(b) ""
'graph5_1b.addtext(4.3, .1, ) "Experience"
'
'freeze(graph5_1c) union.distplot hist
'graph5_1c.addtext(t) ""
'graph5_1c.addtext(l) ""
'graph5_1c.addtext(b) ""
'graph5_1c.addtext(4.5, .1, ) "Union"
'
'freeze(graph5_1d) nonwhite.distplot hist
'graph5_1d.addtext(t) ""
'graph5_1d.addtext(l) ""
'graph5_1d.addtext(b) ""
'graph5_1d.addtext(4.3, .1, ) "Nonwhite"
'
'graph FIgure5_1.merge graph5_1a graph5_1b graph5_1d graph5_1c
'Figure5_1.align(2,1,1)
'show Figure5_1
'
'
''histogram of wage 
'freeze(wagehist)wage.distplot hist
'wagehist.options frameaxes(lb)
'wagehist.addtext(t) ""
'wagehist.addtext(l) Count
'wagehist.addtext(b) Wage
'wagehist.legend -display
'show wagehist
'
''histogram of lwage
'freeze(lwagehist)lwage.distplot hist
'lwagehist.options frameaxes(lb)
'lwagehist.addtext(t) ""
'lwagehist.addtext(l) Count
'lwagehist.addtext(b) Log Wage
'lwagehist.legend -display
'show lwagehist
'
''kernel dist of wage
'freeze(wagekernel)wage.distplot kernel theory
'wagekernel.options frameaxes(lb)
'wagekernel.addtext(t) ""
'wagekernel.addtext(l) Density
'wagekernel.addtext(b) Wage
'wagekernel.addtext(1.67, 0.65, textcolor(blue)) Actual
'wagekernel.addtext(2.7, 1.65, textcolor(red)) Gaussian
'wagekernel.legend -display
'show wagekernel
'
''kernel dist of lwage
'freeze(lwagekernel)lwage.distplot kernel theory
'lwagekernel.options frameaxes(lb)
'lwagekernel.addtext(t) ""
'lwagekernel.addtext(l) Density
'lwagekernel.addtext(b) Log Wage
'lwagekernel.addtext(1.24, 1.11, textcolor(blue)) Actual
'lwagekernel.addtext(2.5, .2, textcolor(red)) Gaussian
'lwagekernel.legend -display
'show lwagekernel
'
''merge graphs
'graph final.merge wagehist lwagehist wagekernel lwagekernel
'
''scatterplot of lwage against educ (with regression line)
'group g1 educ lwage
'freeze(lwageeduc) g1.scat linefit
'lwageeduc.options frameaxes(lb)
'show lwageeduc
'
''scatterplot of lwage against educ (no regression line)
'freeze(lwageeducnoline) g1.scat 
'lwageeducnoline.options frameaxes(lb)
'show lwageeducnoline
'
''scatterplot of lwage against exper (with regression line)
'group g2 exper lwage
'freeze(lwageexper) g2.scat linefit
'lwageexper.options frameaxes(lb)
'show lwageexper
'
''scatterplot of lwage against exper(no regression line)
'freeze(lwageexpernoline) g2.scat 
'lwageexpernoline.options frameaxes(lb)
'show lwageexpernoline
'
''merged scatterplots for lwageeduc and lwageexper
'graph tworegressions.merge lwageeduc lwageexper
'tworegressions.align(2, 1, 0)
'show tworegressions
'
''histogram of lwage and descriptive statistics
'freeze(lwagehistandstats)lwage.hist
'lwagehistandstats.options frameaxes(lb)
'lwagehistandstats.addtext(t) ""
'lwagehistandstats.addtext(l) Count
'lwagehistandstats.addtext(b) Log Wage
'lwagehistandstats.legend -display
'show lwagehistandstats
'
''histogram of wage and descriptive statistics
'freeze(wagehistandstats)wage.hist
'wagehistandstats.options frameaxes(lb)
'wagehistandstats.addtext(t) ""
'wagehistandstats.addtext(l) Count
'wagehistandstats.addtext(b) Log Wage
'wagehistandstats.legend -display
'show wagehistandstats
'
''qqplot for wage
'freeze(qqwage)wage.qqplot 
'qqwage.options frameaxes(lb)
'show qqwage
'
''qqplot for lwage
'freeze(qqlwage)lwage.qqplot 
'qqlwage.options frameaxes(lb)
'show qqlwage
'
''merge qqplots for wage and lwage
'graph qqfinal.merge qqwage qqlwage
'qqfinal.align(2, 1, 0)
'show qqfinal
'
''merge histograms of wage and lwage with stats
'graph finalwithstats.merge wagehistandstats lwagehistandstats
'show finalwithstats
'
''scatterplot of lwage on education, experience and group dummies (Table1b)
'group g3 fit_table1b lwage
'freeze(resscat01) g3.scat 
'resscat01.options frameaxes(lb)
'resscat01.axis(b) range(0,5) 
'resscat01.legend -display
'resscat01.addtext(b) "FIT"
'resscat01.addtext(l) "LWAGE"
'show resscat01
'
''Scatter of resid2 vs Educ
'genr resid2=resid^2
'group g4 educ resid2
'freeze(resid2educ) g4.scat 
'show resid2educ
'
'

'=========== NORMALITY ==============================

' Code by Donato Onorato

' This file produces some graphs for the regression LNWAGE ~ c + EDUC
' to help diagnose issues with normality

'smpl 1 1323
'
''create a matrix to keep track of coefficient changes for leave-one-out
'matrix(1323, 1) coeff_loo
''variable to keep track of which observation to exclude
'genr exclude = 0
'
''loop over all observations, excluding one, and performing the regression
'for !i=1 to 1323
'exclude(!i) = 1
'smpl 1 1323 if exclude=0
'equation curr.ls lwage c educ exper 'most updated wage equation from slides
'coeff_loo(!i, 1) = curr.@coefs(2)
'exclude(!i) =0
'smpl @all
'next
'
''leave one out plot
'freeze(loo) coeff_loo.line
'loo.setelem(1) lpat(12) symbol(1) symbolsize("S")
'
''education by index
'freeze(index) educ.line
'index.setelem(1) lpat(12) symbol(1) symbolsize("S")
'
''leverage plot for education
'freeze(leverage) Table1.lvageplot educ
'
''=======================================================
'
'
'
'
'' ================= QUANTILE REGRESSION =================
'
'smpl 1 1323
'
''Least absolute deviation regression (lad: lwage ~ constant + educ)
'equation Table2.qreg(quant =0.5) lwage c educ
'Table2.fit fit_lad
'
'group a educ lwage fit_lad
'a.scat
'freeze(lad) a.scat
'lad.setelem(2) legend("LWAGE")
'lad.setelem(1)
'lad.setelem(3) legend("Fitted LAD")
'lad.setelem(2) symbol(none) linepattern(solid) lcolor(green)
'
''Quantile regression 10th (quant: lwage ~ c + educ) 
'equation Table3.qreg(quant=0.1) lwage c educ
'Table3.fit fit_10
'
'group quant1 educ lwage fit_10
'quant1.scat
'freeze(q10) quant1.scat
'q10.setelem(2) legend("LWAGE")
'q10.setelem(1)
'q10.setelem(3) legend("Fitted 10th Percentile")
'q10.setelem(2) symbol(none) linepattern(solid) lcolor(orange)
'
''Quantile regression 90th (quant: lwage ~ c + educ) 
'equation Table4.qreg(quant=0.9) lwage c educ
'Table4.fit fit_90
'group quant2 educ lwage fit_90
'quant2.scat
'freeze(q90) quant2.scat
'q90.setelem(2) legend("LWAGE")
'q90.setelem(1)
'q90.setelem(3) legend("Fitted 90th Percentile")
'q90.setelem(2) symbol(none) linepattern(solid) lcolor(purple)
'
''put together all the fitted values for plotting'
'group b educ lwage fit_lad fit_table1 fit_10 fit_90
'
''plot them'
'b.scat 
'
''fix up the graph'
'freeze(mygraph) b.scat
'mygraph.setelem(1) lcolor(black)
'mygraph.setelem(2) legend("LWAGE")
'mygraph.setelem(2) symbol(none) linepattern(solid) lcolor(red)
'mygraph.setelem(3) legend("Fitted LAD")
'mygraph.setelem(3) symbol(none) linepattern(solid) lcolor(green)
'mygraph.setelem(4) legend("Fitted OLS")
'mygraph.setelem(4) symbol(none) linepattern(solid) lcolor(orange)
'mygraph.setelem(5) legend("Fitted 10th Percentile")
'mygraph.setelem(5) symbol(none) linepattern(solid) 
'mygraph.setelem(6) legend("Fitted 90th Percentile") lcolor(purple)
'
'
'========================================


