'mcs22.prg: MCS of a standard normal linear regression
!n=60                              'sample size of econometric model
workfile mcs21.wf1 u 1 !n 
genr i=@trend(0)                   'variable i has values 1,...,n
genr x=i-20*@floor((i-1)/20) 'variable x has values 1,...,20,1,...,20,1,...,20
!beta1=5                           'true value of intercept
!beta2=0.8                         'true value of slope coefficient
!sigma=1.5                         'true value of disturbance stand. deviation
genr Xbeta=!beta1+!beta2*x         'deterministic component of dep. variable
rndseed 9876543210
!R=10000                           'sample size of MCS
matrix (!R,4) simres               'declaration of a !Rx4 matrix simres
for !rep=1 to !R                   'loop of the replications
   genr usim=!sigma*nrnd           'generation vector of IID N[0,!sigma^2]
   genr ysim=Xbeta + usim          'generation of dep. var. N(Xbeta,!sigma^2*I)
   equation eq1.ls ysim=c(1)+c(2)*x   'OLS of simple regression model
   simres(!rep,1)=eq1.@coefs(1)    'all c(1) in 1st column simres
   simres(!rep,2)=eq1.@coefs(2)    'all c(2) in 2nd column simres
   simres(!rep,3)=eq1.@se          'OLS estimate of sigma in 3rd
   simres(!rep,4)=eq1.@stderrs(2)  'StdErr(b2) collected in 4th column
next                               'now all !R replications completed
simres.write mcs22sim.txt   'simres saved as tex file
workfile mcs22sim.wf1 u 1 !R  'workfile size !R
read mcs22sim.txt b1 b2 s b2se  'simres written on 2nd wf
                                             'giving names: b1 b2 s en b2se
genr s2=s*s                        's2 contains estimates of !sigma^2
genr b2var=b2se^2                  'b2var contains estimates of Var(b2)


