'mcs32.prg:  MCS of a classic regression model with nonnormal disturbances
!n=20
workfile mcs32.wf1 u 1 !n
genr i=@trend(0)         
genr x2=i-20*@floor((i-1)/20)  
genr x3=2+0.25*x2^2       
!beta1=5  'intercept
!beta2=0.8  'slope
!sigma=1.5
rndseed 9876543210     
!R=2500                  
matrix (!R,6) simres   
for !rep=1 to !R                                   
   genr u=!sigma*(@rchisq(1)-1)/@sqrt(2)        
   genr y=!beta1+!beta2*x2+u 
   equation eq1.ls y c x2 x3
   simres(!rep,1)=eq1.@coefs(3)  
   simres(!rep,2)=eq1.@stderrs(3)  
   simres(!rep,3)=eq1.@coefs(2) 
   simres(!rep,4)=eq1.@stderrs(2)  
   equation eq2.ls y c x2 
   simres(!rep,5)=eq2.@coefs(2)  
   simres(!rep,6)=eq2.@stderrs(2)  
next                                                  
simres.write mcs32sim.txt             
workfile mcs32sim.wf1 u 1 !R      
read mcs32sim.txt b3 seb3 b2 seb2 b2e seb2e
genr tb3=b3/seb3
genr rejectb3LR= abs(tb3)>@qtdist(0.975,!n-3)
genr rejectb3L= tb3<@qtdist(0.05,!n-3)
genr rejectb3R= tb3>@qtdist(0.95,!n-3)
genr tb2=(b2-!beta2)/seb2       
genr rejectb2LR= abs(tb2)>@qtdist(0.975,!n-3)
genr rejectb2L= tb2<@qtdist(0.025,!n-3)
genr rejectb2R= tb2>@qtdist(0.975,!n-3)
genr tb2e=(b2e-!beta2)/seb2e      
genr rejectb2eLR= abs(tb2e)>@qtdist(0.95,!n-2)
genr rejectb2eL= tb2e<@qtdist(0.05,!n-2)
genr rejectb2eR= tb2e>@qtdist(0.95,!n-2)


