'mcs34.prg: MCS with Box-Cox transformation of explanatory variable  
!n=100       
workfile mcs34.wf1 u 1 !n 
rndseed 12345
genr x=0.2+1.6*rnd   'artificial variable
genr logx=log(x)
!beta1=0  
!beta2=1  
!sigma=0.2
!thetax=0.3
genr xst=(x^!thetax-1)/!thetax
rndseed 9876543210
!R=10000                      
matrix (!R,8) simres     
for !rep=1 to !R                                   
   genr u=!sigma*nrnd     'iid Normal disturbances (0, sigma^2)
   genr y=!beta1 +!beta2*xst  + u
   param c(1) !beta1 c(2) !beta2 c(3) !thetax 
   equation eq1.ls y-c(1)-c(2)*(x^c(3)-1)/c(3) 'NLS estimation
   simres(!rep,1)=eq1.@coefs(2)  'NLS estimate beta2
   simres(!rep,2)=(eq1.@coefs(2)-!beta2)/eq1.@stderrs(2) 
   simres(!rep,3)=eq1.@coefs(3)  'NLS estimate thetax
   simres(!rep,4)=(eq1.@coefs(3)-!thetax)/eq1.@stderrs(3) 
   equation eq2.ls y c xst 'unfeasible model estimated by OLS
   simres(!rep,5)=eq2.@coefs(2)  'OLS estimate beta2
   simres(!rep,6)=(eq2.@coefs(2)-!beta2)/eq2.@stderrs(2) 
   equation eq3.ls y c x
   simres(!rep,7)=eq3.@coefs(2) 
   equation eq4.ls y c logx
   simres(!rep,8)=eq4.@coefs(2) 
next                                                  
simres.write mcs34.txt  
workfile mcs34sim.wf1 u 1 !R  
read mcs34.txt b2 tb2 thetax tthetax b2e tb2e b2lin b2log 
genr rejecttb2=abs(tb2)>@qnorm(0.975)  
genr rejecttlxl=tthetax<@qnorm(0.05) 
genr rejecttlxr=tthetax>@qnorm(0.95) 
genr rejecttb2e=abs(tb2e)>@qtdist(0.975,!n-2)


