'mcs35.prg: MCS with Box-Cox transformation of dependent variable
!n=100
workfile mcs35.wf1 u 1 !n
rndseed 12345
genr x=0.1+1.8*rnd   'artificial variable
!beta1=-1  
!beta2=1  
!sigma=0.1
!thetay=0.6
rndseed 9876543210
!R=10000
matrix (!R,8) simres
for !rep=1 to !R
    genr u=!sigma*nrnd            'iid Normal disturbances (0, sigma^2)
    genr yst=!beta1 +!beta2*x + u
    genr y=(!thetay*yst+1)^(1/!thetay)
    genr logy=log(y)
    param c(1) !beta1 c(2) !beta2 c(3) !thetay c(4) !sigma 'ideal start-up values
    logl ml1    'these 6 lines perform Maximum Likelihood estimation ml1
    ml1.append @logl l 'variable l will contain the n contributions to the log-likelihood
    ml1.append ybc=(y^c(3)-1)/c(3)  'evaluation of Box-Cox transform in this iteration
    ml1.append u = ybc-c(1)-c(2)*x  'evaluation of the residuals in this iteration
    ml1.append l = log(@dnorm(u/c(4)))-log(c(4))+(c(3)-1)*log(y) 'log-likelihood with Jacobian
    ml1.ml   'iterate until sum of log-likelihood contributions has been maximized
    simres(!rep,1)=ml1.c(2)    'ML estimate of beta2
    simres(!rep,2)=(ml1.c(2)-!beta2)/ml1.@stderrs(2) 't-test beta2
    simres(!rep,3)=ml1.c(3)    'ML estimate of thetay
    simres(!rep,4)=(ml1.c(3)-!thetay)/ml1.@stderrs(3)  't-test thetay
    equation eq1.ls yst c x  'infeasible model estimated by OLS 
    simres(!rep,5)=eq1.@coefs(2)                      'OLS estimate beta2
    simres(!rep,6)=(eq1.@coefs(2)-!beta2)/eq1.@stderrs(2)      't-test
    equation eq2.ls y c x
    simres(!rep,7)=eq2.@coefs(2) 'OLS estimate beta2 in linear model
    equation eq3.ls logy c x
    simres(!rep,8)=eq3.@coefs(2) 'OLS estimate beta2 in log model
next
simres.write mcs35.txt 
workfile mcs35sim.wf1 u 1 !R 
read mcs35.txt mlb2 tmlb2 thetay tthetay b2e tb2e b2lin b2log 
genr rejecttmlb2=abs(tmlb2)>@qnorm(0.975)  
genr rejectttyl=tthetay<@qnorm(0.05) 
genr rejectttyr=tthetay>@qnorm(0.95) 
genr rejecttb2e=abs(tb2e)>@qtdist(0.975,!n-2)


