'msc45.prg  MCS of probit and logit models
!n=100    
workfile mcs45.wf1 u 1 !n
rndseed 12345
genr x2=nrnd
!rho23=0.5
genr x3=!rho23*x2+@sqrt(1-!rho23^2)*nrnd
!beta1=1.5
!beta2=1
!beta3=1
!resc=3.14159/@sqrt(3)
!beta1rs=!beta1*!resc
!beta2rs=!beta2*!resc
!beta3rs=!beta3*!resc
genr index=!beta1+!beta2*x2+!beta3*x3   'X*beta
!R=10000
rndseed 9876543210                     
matrix (!R,4) simres     
for !rep=1 to !R                                   
   genr ylatentp=index+nrnd     'index plus iid drawings from N(0,1)
   genr ysimp=(ylatentp>0)      'simulated 0-1 variable y
   param c(1) !beta1 c(2) !beta2 c(3) !beta3    
   equation eqp.binary(d=p) ysimp c x2 x3 'd=p means probit estimation
   simres(!rep,1)=eqp.@coefs(2)        
   simres(!rep,2)=eqp.@stderrs(2)         
   genr ylatentl=index*!resc+@rlogistic 
         'rescaled index plus iid drawings from logistic distribution
   genr ysiml=(ylatentl>0)            'simulated 0-1 variable y
   param c(1) !beta1rs c(2) !beta2rs c(3) !beta3rs       
   equation eql.binary(d=l) ysiml c x2 x3 'd=l means logit estimation
   simres(!rep,3)=eql.@coefs(2)/!resc        
   simres(!rep,4)=eql.@stderrs(2)/!resc
next                                                  
simres.write mcs45sim.txt             
workfile mcs45sim.wf1 u 1 !R      
read mcs45sim.txt b2p seb2p b2l seb2l
genr t2p0=(b2p-!beta2)/seb2p
genr rejt2p0l=t2p0<@qnorm(0.05)
genr rejt2p0r=t2p0>@qnorm(0.95)
genr t2l0=(b2l-!beta2)/seb2l
genr rejt2l0l=t2l0<@qnorm(0.05)
genr rejt2l0r=t2l0>@qnorm(0.95)


